/* SPJS Autocomplete for SharePoint v1.5.1
 * ---------------------------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2014-2017 Alexander Bautz
 * ---------------------------------------------
*/
//# sourceURL=/SPJS/DFFS/plugins/spjs-ac.js
var spjs = spjs || {};

spjs.ac = {
	"version":"1.5.1",
	"versionDate":"February 25, 2017",
	"instance":{},
	"data":{
		"styleTagWritten":false,
		"baseUrl":"",
		"usersInGroup":{},
		"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false,
		"isDispForm":location.href.replace("_layouts/15/start.aspx#/","").split("&")[0].match(/dispform.aspx/i) !== null,
		"debug":GetUrlKeyValue("acDebug") === "1",
		"argObj":{}
	},
	"getLocalized":function(){
		var lcid = "", sArr = ["noItems","addNewItem","noValidItems","invalid","moreItemsLabel","moreItemsMouseover","searching"];
		if(spjs.ac.text !== undefined){
			jQuery.each(sArr,function(i,s){
				if(spjs.ac.text[s] === undefined){
					alert("[SPJS Autocomplete]\n\nIt looks like you have a localized text in your autocomplete solution that needs updating. The attribute \"spjs.ac.text."+s+"\" is missing a translation.");
					spjs.ac.text[s] = "[Missing translation, please update]";
				}
			});
			return;
		}
		if(!spjs.ac.data.isSP07){
			lcid = _spPageContextInfo.currentLanguage.toString();
		}else{
			lcid = L_Menu_LCID;
		}		
		switch(lcid){
			case "1044":
				spjs.ac.text = {
					"noItems":"Ingen elementer samsvarer med søket",
					"addNewItem":"Legg til {0} i listen?",
					"noValidItems":"Ingen gyldige elementer funnet",
					"invalid":"Ugyldig verdi",
					"moreItemsLabel":"Viser de {0} første elementene",
					"moreItemsMouseover":"Fortsett å skrive for å begrense søket",
					"searching":"Søker etter: "
				};
			break;
			case "1031":
				spjs.ac.text = {
					"noItems":"Die Suche hat keinen Treffer ergeben",
					"addNewItem":"{0} Einträge zur Liste hinzufügen?",
					"noValidItems":"Die Suche hat keinen gültigen Treffer ergeben",
					"invalid":"Ungültiger Wert",
					"moreItemsLabel":"Anzeige der ersten {0} Eintrage.",
					"moreItemsMouseover":"Fahren Sie mit der Eingabe fort um die Suche einzuengen",
					"searching":"Suche nach: "
				};
			break;
			default:
				spjs.ac.text = {
					"noItems":"No items match your search",
					"addNewItem":"Add {0} to the list?",
					"noValidItems":"No valid items match your search",
					"invalid":"Invalid value",
					"moreItemsLabel":"Showing the first {0} items",
					"moreItemsMouseover":"Continue typing to narrow your search",
					"searching":"Searching for: "
				};
		}
	},	
	"applyCSS":function(){
		var b = [];
		b.push("<style type=\"text/css\">");
		b.push(".spjs_acWrap{background-color:#FFFFFF;border:1px silver solid;display:none;position:absolute;min-width:300px;cursor:default;white-space:nowrap;z-index:999;}");
		b.push(".spjs_acItem{border-left:2px transparent solid;border-right:2px transparent solid;padding:4px;cursor:default;white-space:nowrap;border-bottom:1px #efefef solid;}");
		b.push(".spjs_acSelected{background-color:#eff6fc;border-left:2px #0072C6 solid;}");
		b.push(".spjs_acNotFound{padding:4px;cursor:default;white-space:nowrap;color:#818181;}");
		b.push(".spjs_acError{border-color:#E3170D!important;}");
		b.push(".spjs_acItemMoreItems{border-top:1px silver solid;padding:4px;color:#818181;}");
		b.push(".spjs_acAddToList{border-top:1px silver solid;padding:4px;color:#818181;}");
		b.push(".spjs_acDownArr{color:#ababab;position:absolute;margin:1px 0px 0px -20px}");
		b.push(".spjs_ac_multi_clicked{background-color:#0072C6;color:#ffffff;}");
		b.push(".spjs_ac_multi_selectedWrap{float:left;margin:2px 4px 2px 0px;cursor:default;background-color:#0072C6;color:#ffffff;}");
		b.push(".spjs_ac_multi_selected{float:left;vertical-align:middle;padding:3px;}");
		b.push(".spjs_ac_multi_removeSelected{float:left;cursor:default;padding:3px;color:#0072C6;color:#ffffff;}");
		b.push(".spjs_unselectable{-webkit-touch-callout: none;-webkit-user-select: none;-khtml-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;}");
		b.push(".spjs_ac_multi_removeSelected:hover{background-color:#D41816;color:#ffffff;}");
		b.push(".spjs_dot_green{vertical-align:middle;margin-left:5px;height:12px;width:12px;display:inline-block;background-image:url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAwAAAAMCAIAAADZF8uwAAAABGdBTUEAALGPC/xhBQAAAAlwSFlzAAAOwgAADsIBFShKgAAAABl0RVh0U29mdHdhcmUAcGFpbnQubmV0IDQuMC4xMzQDW3oAAAAVSURBVChTY5A8IkkQjSoahIqOSAIACASKYVOdn34AAAAASUVORK5CYII=')}");
		b.push(".spjs_dot_red{vertical-align:middle;margin-left:5px;height:12px;width:12px;display:inline-block;background-image:url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAwAAAAMCAIAAADZF8uwAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAHBhaW50Lm5ldCA0LjAuMTM0A1t6AAAAFElEQVQoU2N4LM5LEI0qGoSKxHkBy7yT8bIrBA8AAAAASUVORK5CYII=')}");
		b.push("<\/style>");
		jQuery(document).ready(function(){
			jQuery("body").append(b.join(""));
		});
		spjs.ac.data.styleTagWritten = true;
	},
	"imgErr":function(img){
		jQuery(img).attr("src","/_layouts/images/IMNIDLE.PNG");
	},
	"textField":function(argObj){
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		if(jQuery("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "textField";
			spjs.ac.add(argObj);
		}
	},
	"peoplePicker":function(argObj){
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		if(spjs.utility.version < 1.181){
			alert("[Autocomplete for SharePoint]\n\nYou must update spjs-utility.js to v1.181 or above.");
		}
		if(jQuery("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "peoplePicker";
			argObj.listGuid = "UserInfo";
			if(spjs.ac.data.isSP13 && !argObj.forceOn2013){
				alert("[SPJS Autocomplete]\n\nThis solution cannot be used for a people picker field in SP2013 as this field already have built in autocomplete.");
			}else{
				jQuery(document).ready(function(){
					spjs.ac.add(argObj);
				});
			}
		}
	},
	"hideHelp":function(fin){
		jQuery("#spjs_acHelp_"+fin).hide().next().focus().trigger("click");
	},
	"add":function(argObj){
		if(spjs.ac.data.isSP13){
			if(jQuery("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.ac.add(argObj);
				},10);
				return;
			}
		}
		if(fields[argObj.applyTo] === undefined){
			alert("[SPJS Autocomplete for SharePoint]\n\nThe field \""+argObj.applyTo+"\" could not be found.");
			return;
		}		
		if(!spjs.ac.data.isSP07){
			spjs.ac.data.baseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		}else{
			spjs.ac.data.baseUrl = L_Menu_BaseUrl;
		}
		var hb, w = jQuery(fields[argObj.applyTo]).find("input:text,textarea").first().width();
		if(!spjs.ac.data.styleTagWritten){
			spjs.ac.applyCSS();
		}
		spjs.ac.data.argObj[argObj.applyTo] = argObj;
		spjs.ac.instance[argObj.applyTo] = {
			"applyTo":argObj.applyTo,
			"clicked":false,
			"trigger":false,
			"loadVal":getFieldValue(argObj.applyTo).toString(),
			"setFields":argObj.setFields !== undefined ? argObj.setFields : [],
			"timeout":0,
			"text":{},
			"selectedIndex":null,
			"selectedValue":"",
			"currentValue":"",
			"foundExactMatch":0,
			"multi":argObj.multiselect === true ? true : false,
			"multiselectSeparator":argObj.multiselectSeparator !== undefined ? argObj.multiselectSeparator : ", ",
			"selectedValueMulti":[],
			"selectedIndexMulti":[]
		};
		if(spjs.ac.instance[argObj.applyTo].loadVal.split(";#").length > 1){
			spjs.ac.instance[argObj.applyTo].loadVal = spjs.ac.instance[argObj.applyTo].loadVal.split(";#")[1];
		}
		spjs.ac.getLocalized();
		spjs.ac.instance[argObj.applyTo].text = spjs.ac.text;
		if(argObj.listGuid===undefined){
			alert("[spjs.ac]\nThe configuration for field \""+argObj.applyTo+"\" has an invalid list GUID configured.");
			return;
		}
		jQuery(fields[argObj.applyTo]).attr("spjs_ac","1");	
		hb = [];
		hb.push("<div id='spjs_acWrap_"+argObj.applyTo+"' style='white-space:nowrap;'>");
		hb.push("<span id='spjs_acHelp_"+argObj.applyTo+"' onclick='spjs.ac.hideHelp(\""+argObj.applyTo+"\");' style='position:absolute;padding:3px 0px 0px 4px;color:#818181;display:none;'>"+argObj.helpText+"</span>");
		hb.push("<input id='spjs_ac_"+argObj.applyTo+"' type='text' class='ms-long' style='min-height:13px;margin:0px;' value='"+spjs.ac.instance[argObj.applyTo].loadVal+"' autocomplete='off'>");
		hb.push("<span style='cursor:default;width:20px;display:inline-block;text-align:center;'>");
		hb.push("<img id='prosessingImg_"+argObj.applyTo+"' class='spjs_ac_icon_"+argObj.applyTo+"' src='/_layouts/"+(spjs.ac.data.isSP13 ? "15/" : "")+"images/loadingcirclests16.gif' onerror='spjs.ac.imgErr(this)' style='height:16px;border:0px;vertical-align:middle;display:none' />");
		hb.push("<span id='statusImgGreen_"+argObj.applyTo+"' class='spjs_ac_icon_"+argObj.applyTo+" spjs_dot_green' style='display:none;'>&nbsp;</span>");
		hb.push("<span id='statusImgRed_"+argObj.applyTo+"' class='spjs_ac_icon_"+argObj.applyTo+" spjs_dot_red' style='display:none;'>&nbsp;</span>");
		hb.push("</span>");
		hb.push("<div id='spjs_acWrapFormValidation_"+argObj.applyTo+"'></div>");
		hb.push("</div>");
		hb.push("<div class='spjs_acWrap' style='min-width:"+w+"px;' id='spjs_acPlaceholder_"+argObj.applyTo+"'></div>");
		if(argObj.multiselect){
			if(fields[argObj.applyTo].FieldType === "SPFieldText"){
				hb.push("<div style='color:red;'>This field is multiselect. Please go to list settings and change the field to Multiple lines of text: Plain text.</div>");
			}
			if(fields[argObj.applyTo].FieldType === "SPFieldNote_EHTML"){
				hb.push("<div style='color:red;'>Please go to list settings and change the field to Multiple lines of text: Plain text.</div>");
			}
			hb.push("<div id='spjs_acMultiselect_"+argObj.applyTo+"' style='overflow:auto'></div>");
		}
		hb.push("<span class='spjs_acError' id='spjs_acErrPlaceholder_"+argObj.applyTo+"'></span>");		
		if(spjs.ac.data.debug){
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span:first").after(hb.join(""));
		}else{
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span:first").hide().after(hb.join(""));
		}
		if(jQuery(fields[argObj.applyTo]).find("span.ms-formvalidation").length > 0){
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span.ms-formvalidation, td.ms-formbody span.ms-error").appendTo(jQuery("#spjs_acWrapFormValidation_"+argObj.applyTo));
		}
		if(argObj.listOptionsOnFocus !== undefined && argObj.listOptionsOnFocus){
			jQuery("#spjs_ac_"+argObj.applyTo).after("<span class='spjs_acDownArr' onclick='jQuery(this).prev().click();'>\u25BC</span>");
		}		
		jQuery(fields[argObj.applyTo]).find("input:last").on("focus",function(){
			jQuery("#spjs_acHelp_"+argObj.applyTo).hide();
			spjs.ac.instance[argObj.applyTo].pVal = jQuery(this).val();
		}).on("click",function(e){
			if(argObj.listOptionsOnFocus || jQuery(this).hasClass("spjs_acError")){
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
					spjs.ac.handle(argObj);					
				},500);
			}
		}).on("keyup",function(e){
			if(e.keyCode === 13 || e.keyCode === 38 || e.keyCode === 40){
				return;
			}
			if(argObj.minLengthBeforeSearch === undefined){
				argObj.minLengthBeforeSearch = 3;
			}
			if(jQuery("#spjs_ac_"+argObj.applyTo).val().length < argObj.minLengthBeforeSearch){
				return;
			}
			clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
			spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
				spjs.ac.handle(argObj);
			},500);
		}).on("blur",function(){
			if(jQuery(this).val() === ""){
				jQuery("#spjs_acHelp_"+argObj.applyTo).show();
			}
			if(spjs.ac.instance[argObj.applyTo].multi){
				jQuery("#spjs_acPlaceholder_"+argObj.applyTo).on("mouseleave",function(){
					jQuery(this).hide().html("");
				});
			}else{
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
					var cVal = jQuery("#spjs_ac_"+argObj.applyTo).val();
					if(!spjs.ac.instance[argObj.applyTo].clicked || cVal === "" || jQuery.inArray(cVal,spjs.ac.instance[argObj.applyTo].choicesArr) < 0){
						if(jQuery("#spjs_ac_"+argObj.applyTo).val() === ""){
							spjs.ac.instance[argObj.applyTo].selectedIndex = 0;						
						}
						spjs.ac.verify(argObj.applyTo);
					}
					// jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");						
				},250);
			}
		}).on("keydown",function(e){
			var sItem;
			if(e.keyCode === 38 || e.keyCode === 40){
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				if(jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected").length===0){
					if(e.keyCode === 40){
						sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
					}else if(e.keyCode === 38){
						sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
					}
				}else{
					sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
					if(e.keyCode === 40){ // Down
						sItem.removeClass("spjs_acSelected");
						if(sItem.next().length>0){
							sItem.nextAll().each(function(i,e){
								if(jQuery(e).hasClass("spjs_acItem")){
									sItem = jQuery(e);
									return false;
								}else if(jQuery(e).hasClass("spjs_acItemMoreItems")){
									sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");					
								}							
							});
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
						}
					}else if(e.keyCode === 38){ // Up
						sItem.removeClass("spjs_acSelected");
						if(sItem.prev().length>0){
							sItem.prevAll().each(function(i,e){
								if(jQuery(e).hasClass("spjs_acItem")){
									sItem = jQuery(e);
									return false;
								}else{
									sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last");					
								}						
							});							
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
						}						
					}
				}
			}else if(e.keyCode === 13){
				sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
				if(sItem.length>0){
					spjs.ac.instance[argObj.applyTo].selectedIndex = sItem.attr("aindex");
					spjs.ac.instance[argObj.applyTo].selectedValue = sItem.find("div:first").text();
					jQuery("#spjs_ac_"+argObj.applyTo).val(spjs.ac.instance[argObj.applyTo].selectedValue);
					jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
					spjs.ac.instance[argObj.applyTo].clicked = true;
					spjs.ac.verify(argObj.applyTo);
				}else{
					spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
					spjs.ac.instance[argObj.applyTo].selectedValue = "";
				}
				return false;
			}else if(e.keyCode === 32){
				sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
				if(sItem.length>0){
					spjs.ac.select(argObj.applyTo,sItem[0]);
					return false;
				}
			}else if(e.keyCode === 9){
				jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
			}
		});
		if(jQuery("#spjs_ac_"+argObj.applyTo).val() !== ""){
			if(argObj.reValidateOnLoad && !argObj.multiselect){
				spjs.ac.instance[argObj.applyTo].trigger = true;			
				clearTimeout(spjs.ac.instance[argObj.applyTo].timeout);
				spjs.ac.instance[argObj.applyTo].timeout = setTimeout(function(){
					spjs.ac.handle(argObj);
				},500);
			}
			if(argObj.multiselect){
				spjs.ac.preloadMulti(argObj.applyTo);
			}
		}else{
			jQuery("#spjs_acHelp_"+argObj.applyTo).show();
		}
	},
	"delete":function(fin){
    	spjs.ac.destroy(fin); 
    },
	"destroy":function(fin){
		if(jQuery("#spjs_acWrap_"+fin).length > 0){
			jQuery("#spjs_acWrap_"+fin).remove();
			jQuery("#spjs_acPlaceholder_"+fin).remove();
			jQuery("#spjs_acErrPlaceholder_"+fin).remove();
			jQuery(fields[fin]).attr("spjs_ac","0");
			jQuery(fields[fin]).find("td.ms-formbody span:first").show();
			clearTimeout(spjs.ac.instance[fin].timeout);			
			delete spjs.ac.instance[fin];
		}
	},
	"GetUserCollectionFromGroup":function(gName){
		var result = {"items":[]}, pArr = [["ID","ID"], ["Name","Title"], ["LoginName","Name"], ["Email","EMail"], ["IsSiteAdmin","IsSiteAdmin"],["IsDomainGroup","IsDomainGroup"]], d;
		spjs_wrapSoapRequest(spjs.ac.data.baseUrl + '/_vti_bin/usergroup.asmx', 
		'http://schemas.microsoft.com/sharepoint/soap/directory/GetUserCollectionFromGroup',
		'<GetUserCollectionFromGroup xmlns="http://schemas.microsoft.com/sharepoint/soap/directory/"><groupName>' + gName + '</groupName></GetUserCollectionFromGroup>',
		function(data){
			jQuery('User', data).each(function(idx, data){
				d = {};
				jQuery.each(pArr,function(i,a){
					d[a[1]] = jQuery(data).attr(a[0]);
				});
				result.items.push(d);
			});
		});
		result.count = result.items.length;
		return result;
	},
	"searchUserCollectionFromGroup":function(str,gName){
		if(spjs.ac.data.usersInGroup[gName] === undefined){
			spjs.ac.data.usersInGroup[gName] = spjs.ac.GetUserCollectionFromGroup(gName);
		}
		var fRes = {"items":[]}, m, pArr = ["ID", "Title", "Name", "EMail", "IsSiteAdmin", "IsDomainGroup"];
		jQuery.each(spjs.ac.data.usersInGroup[gName].items,function(i,o){
			m = false;			
			jQuery.each(o,function(j,p){
				if(jQuery.inArray(j,pArr) > -1){
					if(p.toLowerCase().indexOf(str.toLowerCase()) > -1){
						m = true;
					}
				}
			});
			if(m){
				fRes.items.push(o);
			}
		});
		fRes.count = fRes.items.length;
		return fRes;
	},
	"getOrderBy":function(a){
		var b = [];
		if(a.orderBy !== undefined){
			if(!jQuery.isArray(a.orderBy)){
				a.orderBy = [a.orderBy];
			}
			b.push("<OrderBy>");
			jQuery.each(a.orderBy,function(i,f){
				if(typeof f === "object"){
					b.push("<FieldRef Name='"+f.fin+"' Ascending='"+(f.ascending !== undefined ? String(f.ascending).toUpperCase() : "TRUE")+"' />");
				}else{
					b.push("<FieldRef Name='"+f+"' />");
				}				
			});
			b.push("</OrderBy>");
		}else{
			b.push("<OrderBy><FieldRef Name='"+a.showField+"' /></OrderBy>");
		}
		return b.join("");
	},
	"handle":function(argObj){
		spjs.ac.instance[argObj.applyTo].addNew = false;
		var val, viewFields, query, res;
		val = jQuery("#spjs_ac_"+argObj.applyTo).val();		
		spjs.ac.instance[argObj.applyTo].currentValue = val;		
		spjs.ac.instance[argObj.applyTo].clicked = false;
		if(val !== "" || (val === "" && argObj.listOptionsOnFocus)){
			if(!spjs.ac.instance[argObj.applyTo].trigger && val !== "" && jQuery("#spjs_acPlaceholder_"+argObj.applyTo).css("display") === "none"){
				jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html("<div style='padding:4px;color:#818181;'>"+spjs.ac.instance[argObj.applyTo].text.searching+val+"</div>").show();
			}
			jQuery(".spjs_ac_icon_"+argObj.applyTo).hide();
			jQuery("#prosessingImg_"+argObj.applyTo).show();
			setTimeout(function(){
				if(argObj.fieldType === "peoplePicker"){
					if(argObj.chooseFromUserGroup !== null && argObj.chooseFromUserGroup !== ""){
						if(typeof argObj.chooseFromUserGroup === "number"){
							argObj.chooseFromUserGroup = getUserInfo_v2(argObj.chooseFromUserGroup).Name;
						}
						res = spjs.ac.searchUserCollectionFromGroup(val,argObj.chooseFromUserGroup);
					}else{
						query = [];						
						if(val === ""){
							if(argObj.showUsersOnly){
								query.push("<And><IsNotNull><FieldRef Name='ID' /></IsNotNull><Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq></And>");
							}else{
								query.push("<IsNotNull><FieldRef Name='ID' /></IsNotNull>");
							}
						}else{
							query.push("<Or>");
							query.push("<Or>");
							query.push("<Contains><FieldRef Name='Title' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("<Contains><FieldRef Name='Name' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("</Or>");
							query.push("<Contains><FieldRef Name='EMail' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("</Or>");
						}
						if(argObj.showUsersOnly){
							query.unshift("<And>");
							query.push("<Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq>");
							query.push("</And>");
						}
						query.unshift("<Where>");
						query.push("</Where>");
						query.push(spjs.ac.getOrderBy(argObj));					
						viewFields = ["ID"];
						viewFields.push(argObj.showField);
						if(argObj.optionDetailFields !== undefined){
							jQuery.each(argObj.optionDetailFields,function(k,ofv){
								viewFields.push(ofv);
							});
						}
						jQuery.each(spjs.ac.instance[argObj.applyTo].setFields,function(i,o){
							if(jQuery.isArray(o.fromFIN)){
								jQuery.each(o.fromFIN,function(i,f){
									viewFields.push(f);
								});
							}else{
								viewFields.push(o.fromFIN);
							}
						});
						res = spjs.utility.queryItemsThrottled({"listName":argObj.listGuid,"query":query.join(""),"viewFields":viewFields,"rowLimit":argObj.rowLimit});
					}
				}else{
					if(val === "" && argObj.listOptionsOnFocus){
						query = [];
						query.push("<IsNotNull><FieldRef Name='"+argObj.showField+"' /></IsNotNull>");
						if(argObj.filterCAML !== undefined && argObj.filterCAML !== ""){
							query.push(argObj.filterCAML.replace(/<Where>|<\/Where>/g,""));
							query.unshift("<And>");
							query.push("</And>");
						}						
						query.unshift("<Where>");
						query.push("</Where>");
						query.push(spjs.ac.getOrderBy(argObj));
					}else{
						query = [];
						query.push("<Contains><FieldRef Name='"+argObj.showField+"' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
						if(argObj.filterCAML !== undefined && argObj.filterCAML !== ""){
							query.push(argObj.filterCAML.replace(/<Where>|<\/Where>/g,""));
							query.unshift("<And>");
							query.push("</And>");
						}						
						query.unshift("<Where>");
						query.push("</Where>");
						query.push(spjs.ac.getOrderBy(argObj));
					}
					query = query.join("");
					viewFields = ["ID"];
					viewFields.push(argObj.showField);
					if(argObj.optionDetailFields !== undefined){
						jQuery.each(argObj.optionDetailFields,function(k,ofv){
							viewFields.push(ofv);
						});
					}
					jQuery.each(spjs.ac.instance[argObj.applyTo].setFields,function(i,o){
						if(jQuery.isArray(o.fromFIN)){
							jQuery.each(o.fromFIN,function(i,f){
								viewFields.push(f);
							});
						}else{
							viewFields.push(o.fromFIN);
						}
					});
					res = spjs.utility.queryItemsThrottled({"listName":argObj.listGuid,"listBaseUrl":argObj.listBaseUrl,"query":query,"viewFields":viewFields,"rowLimit":argObj.rowLimit});
				}
				jQuery("#spjs_acErrPlaceholder_"+argObj.applyTo).hide();
				if(spjs.ac.data.debug){
					console.log(res);
				}				
				var b = [];
				if(res.count===-1){
					jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
					jQuery("#spjs_acErrPlaceholder_"+argObj.applyTo).html("Ensure the list \""+argObj.listGuid+"\" exists on \""+argObj.listBaseUrl+"\", and that the field \""+argObj.showField+"\" does exist in that list.").show();
					jQuery(fields[argObj.applyTo]).find("input:text,textarea").first().val("");
				}else if(res.count===0){
					jQuery(fields[argObj.applyTo]).find("input:text,textarea").first().val("");
					if(val !== ""){
						b.push("<div class='spjs_acNotFound'>"+spjs.ac.instance[argObj.applyTo].text.noItems);
						if(argObj.allowAddNew){
							b.push(" - <span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+val+"</i>")+"</span>");
						}
						b.push("</div>");
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html(b.join("")).show();
						jQuery("#spjs_ac_"+argObj.applyTo).addClass("spjs_acError").attr("title",spjs.ac.instance[argObj.applyTo].text.invalid);
						jQuery(".spjs_ac_icon_"+argObj.applyTo).hide();
						jQuery("#statusImgRed_"+argObj.applyTo).show();				
					}else{
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide().html("");
					}
					spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
				}else{
					spjs.ac.instance[argObj.applyTo].sFields = {};
					spjs.ac.instance[argObj.applyTo].foundExactMatch = 0;
					spjs.ac.getChoices(res.items,argObj,val,argObj.fieldType);
					if(res.count > 0 && spjs.ac.instance[argObj.applyTo].choices.length === 0){
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html("<div class='spjs_acNotFound'>"+spjs.ac.instance[argObj.applyTo].text.noValidItems+"</div>");
						jQuery("#spjs_ac_"+argObj.applyTo).focus();
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).show();						
					}else{
						if(spjs.ac.instance[argObj.applyTo].trigger){
							if(spjs.ac.instance[argObj.applyTo].foundExactMatch > 0){
								spjs.ac.instance[argObj.applyTo].selectedIndex = spjs.ac.instance[argObj.applyTo].foundExactMatch;
								spjs.ac.instance[argObj.applyTo].selectedValue = jQuery("#spjs_ac_"+argObj.applyTo).val();		
								spjs.ac.instance[argObj.applyTo].currentValue = spjs.ac.instance[argObj.applyTo].selectedValue;								
							}
							spjs.ac.instance[argObj.applyTo].trigger = false;
							spjs.ac.verify(argObj.applyTo);
						}else{
							if(spjs.ac.instance[argObj.applyTo].foundExactMatch > 0){
								spjs.ac.instance[argObj.applyTo].selectedIndex = spjs.ac.instance[argObj.applyTo].foundExactMatch;
								spjs.ac.instance[argObj.applyTo].selectedValue = jQuery("#spjs_ac_"+argObj.applyTo).val();
								spjs.ac.instance[argObj.applyTo].currentValue = spjs.ac.instance[argObj.applyTo].selectedValue;								
							}else{
								if(spjs.ac.instance[argObj.applyTo].multi){
									jQuery(fields[argObj.applyTo]).find("input:text,textarea").first().val(spjs.ac.instance[argObj.applyTo].selectedValueMulti.join(spjs.ac.instance[argObj.applyTo].multiselectSeparator));
								}else{
									jQuery(fields[argObj.applyTo]).find("input:text,textarea").first().val("");
								}
								
								spjs.ac.instance[argObj.applyTo].selectedIndex = 0;
							}
							if(spjs.ac.instance[argObj.applyTo].choices.length === argObj.rowLimit){
								spjs.ac.instance[argObj.applyTo].choices.push("<div class='spjs_acItemMoreItems' title='"+spjs.ac.instance[argObj.applyTo].text.moreItemsMouseover+"'>"+spjs.ac.instance[argObj.applyTo].text.moreItemsLabel.replace("{0}",argObj.rowLimit));
								if(argObj.allowAddNew && val !== "" && jQuery.inArray(val,spjs.ac.instance[argObj.applyTo].choicesArr)<0){
									spjs.ac.instance[argObj.applyTo].choices.push(" - <span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+val+"</i>")+"</span>");
								}
								spjs.ac.instance[argObj.applyTo].choices.push("</div>");
							}else{
								if(argObj.allowAddNew && val !== ""){
									if(jQuery.inArray(val,spjs.ac.instance[argObj.applyTo].choicesArr)<0){
										spjs.ac.instance[argObj.applyTo].choices.push("<div class='spjs_acAddToList'><span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.instance[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+val+"</i>")+"</span></div>");
									}
								}
							}
							jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html(spjs.ac.instance[argObj.applyTo].choices.join(""));										
							jQuery("#spjs_ac_"+argObj.applyTo).focus();
							jQuery("#spjs_acPlaceholder_"+argObj.applyTo).show();
						}
					}
				}
				setTimeout(function(){
					jQuery("#prosessingImg_"+argObj.applyTo).hide();
					jQuery("#statusImg_"+argObj.applyTo).show();					
				},500);
			},100);			
		}
	},
	"addNewItem":function(fin){
		var arg = spjs.ac.data.argObj[fin], a = spjs.ac.instance[fin], v = a.currentValue;
		if(arg.isLookupInSelf){
			jQuery(fields[a.applyTo]).find("input:text,textarea").first().val(v);
			a.selectedValue = v;
			a.addNew = true;
			jQuery("#spjs_ac_"+fin).removeClass("spjs_acError");
		}else{
			OpenPopUpPage(arg.listBaseUrl+"/_layouts/15/listform.aspx?PageType=8&ListId="+arg.listGuid,function(result){
				if(result === 1){
					jQuery("#spjs_ac_"+fin).val(v);
					spjs.ac.handle(arg);
				}
			});
			spjs.ac.prefill(arg.showField,v);
			// New in v1.4.7
			if(a.setChildFields !== undefined){
				a.addNewAdditionalFields = a.setChildFields;
			}
			if(a.addNewAdditionalFields !== undefined && a.addNewAdditionalFields !== null){
				jQuery.each(a.addNewAdditionalFields,function(i,o){
					spjs.ac.prefill(o.toFIN,getFieldValue(o.fromFIN));
				});
			}
		}
	},
	"prefill":function(fin,val){
		var dlg = SP.UI.ModalDialog.get_childDialog().get_frameElement();
		if(dlg !== undefined){
			if(jQuery(dlg).contents().find("input[id^='"+fin+"_']").length < 1){
				setTimeout(function(){
					spjs.ac.prefill(fin,val);
				},100);
			}else{
				jQuery(dlg).contents().find("input[id^='"+fin+"_']").val(val);
			}
		}		
	},
	"getChoices":function(items,argObj,val,type){
		spjs.ac.instance[argObj.applyTo].choices = [];
		spjs.ac.instance[argObj.applyTo].choicesArr = [];
		var bSel, skip, sVal, lVal, mVal, mArr, b, unique = {};
		bSel = null;
		jQuery.each(items,function(i,item){
			skip = false;
			mArr = [];
			spjs.ac.instance[argObj.applyTo].sFields[item.ID] = [];
			jQuery.each(spjs.ac.instance[argObj.applyTo].setFields,function(j,o){
				if(jQuery.isArray(o.fromFIN)){
					sVal = [];
					jQuery.each(o.fromFIN,function(i,f){
						sVal.push(item[f] !== null ? item[f] : "");
					});
					if(o.joinBy !== undefined && o.joinBy !== ""){
						sVal = sVal.join(o.joinBy);
					}			
				}else{
					sVal = item[o.fromFIN] !== null ? item[o.fromFIN] : "";
				}
				if(sVal === "" && o.skipIfEmpty){
					skip = true;
					return false;
				}			
				spjs.ac.instance[argObj.applyTo].sFields[item.ID].push({"fin":o.toFIN,"val":sVal,"pf":o.parseFunction !== undefined ? o.parseFunction : ""});
			});
			if(skip){
				return;
			}
			lVal = item[argObj.showField];
			if(unique[lVal] !== undefined && argObj.enforceUniqueValues){
				return;
			}
			unique[lVal] = true;
			lVal = lVal.replace(/'/g,"&apos;").replace(/"/g,"&quot;");
			if(lVal.split(";#").length>1){
				lVal = lVal.split(";#")[1];
			}
			b = [];
			if(type === "peoplePicker" && item.EMail !== null){
				b.push("<div title='"+item.EMail+"' aindex='"+item.ID+"' class='spjs_acItem");
			}else{
				b.push("<div title='"+lVal+"' aindex='"+item.ID+"' class='spjs_acItem");
			}
			if(lVal === val){
				if(bSel === null){
					b.push(" spjs_acSelected");
					bSel = true;
					spjs.ac.instance[argObj.applyTo].foundExactMatch = item.ID;
				}else if(bSel){
					bSel = false;
					spjs.ac.instance[argObj.applyTo].foundExactMatch = 0;
				}					
			}
			if(jQuery.inArray(lVal,spjs.ac.instance[argObj.applyTo].selectedValueMulti) > -1){
				b.push(" spjs_ac_multi_clicked");
			}
			if(argObj.optionDetailFields !== undefined){
				jQuery.each(argObj.optionDetailFields,function(k,odv){
					mVal = item[odv] !== null ? item[odv] : "";
					if(mVal.split(";#").length>1){
						mVal = mVal.split(";#")[1];
					}
					mArr.push("<div>"+mVal+"</div>");
				});
			}
			b.push("' onmouseover='spjs.ac.hover(\""+argObj.applyTo+"\",this)' onclick='spjs.ac.select(\""+argObj.applyTo+"\",this)' value='"+lVal+"'><div class='spjs_acLabel'>"+lVal+"</div>"+mArr.join("")+"</div>");
			spjs.ac.instance[argObj.applyTo].choices.push(b.join(""));
			spjs.ac.instance[argObj.applyTo].choicesArr.push(lVal);
		});
	},
	"hover":function(fin,elm){
		jQuery(".spjs_acSelected").removeClass("spjs_acSelected");
		jQuery(elm).addClass("spjs_acSelected");
	},
	"select":function(fin,elm){
		var index, sId;		
		if(spjs.ac.instance[fin].multi){
			if(jQuery(elm).hasClass("spjs_ac_multi_clicked")){
				jQuery(elm).removeClass("spjs_ac_multi_clicked");
				sId = spjs.ac.idFromString(jQuery(elm).find(".spjs_acLabel").text());
				spjs.ac.removeSelection(document.getElementById(fin+"_"+sId),fin);
				return;
			}
		}
		spjs.ac.instance[fin].clicked = true;
		jQuery("#spjs_ac_"+fin).val(jQuery(elm).find(".spjs_acLabel").text());
		if(elm === undefined){
			elm = jQuery("#spjs_acPlaceholder_"+fin).find("div.spjs_acSelected");			
		}
		index = jQuery(elm).attr("aindex");
		spjs.ac.instance[fin].selectedIndex = index;
		spjs.ac.instance[fin].selectedValue = jQuery("#spjs_ac_"+fin).val();		
		spjs.ac.instance[fin].currentValue = spjs.ac.instance[fin].selectedValue;

		if(spjs.ac.instance[fin].multi){
			jQuery(elm).addClass("spjs_ac_multi_clicked").one("click",function(){
				jQuery(elm).removeClass("spjs_ac_multi_clicked");
				sId = spjs.ac.idFromString(spjs.ac.instance[fin].selectedValue);
				spjs.ac.removeSelection(document.getElementById(fin+"_"+sId),fin);
				// jQuery("#spjs_ac_multi_"+fin+"_"+jQuery(elm).attr("aindex")).remove();
			});
		}else{
			jQuery("#spjs_acPlaceholder_"+fin).hide().html("");
		}
		jQuery("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
		spjs.ac.verify(fin);
	},
	"verify":function(fin){
		var index, cVal;
		cVal = jQuery("#spjs_ac_"+fin).val();
		spjs.ac.instance[fin].clicked = false;
		index = spjs.ac.instance[fin].selectedIndex;
		if(index === null){
			if(jQuery.inArray(cVal,spjs.ac.instance[fin].choicesArr)<0){
				jQuery("#dffs_"+fin).find("input:text,textarea").first().val("");
				jQuery("#spjs_ac_"+fin).addClass("spjs_acError").attr("title",spjs.ac.instance[fin].text.invalid);
				jQuery(".spjs_ac_icon_"+fin).hide();
				jQuery("#statusImgRed_"+fin).show();
			}
		}else if(index===0 || spjs.ac.instance[fin].selectedValue !== cVal){
			if(spjs.ac.instance[fin].addNew){
				jQuery(".spjs_ac_icon_"+fin).hide();
				jQuery("#statusImgGreen_"+fin).show();
			}else{
				if(!spjs.ac.instance[fin].multi){
					jQuery("#dffs_"+fin).find("input:text,textarea").first().val("");
					jQuery("#spjs_ac_"+fin).val(cVal);
					jQuery.each(spjs.ac.instance[fin].setFields,function(i,o){
						setFieldValue(o.toFIN,"");
					});
					if(cVal !== ""){
						jQuery("#spjs_ac_"+fin).addClass("spjs_acError").attr("title",spjs.ac.instance[fin].text.invalid);
						jQuery(".spjs_ac_icon_"+fin).hide();
						jQuery("#statusImgRed_"+fin).show();
					}else{
						jQuery("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
						jQuery(".spjs_ac_icon_"+fin).hide();
					}
				}
			}		
		}else{
			jQuery("#spjs_acHelp_"+fin).hide();
			jQuery("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
			jQuery(".spjs_ac_icon_"+fin).hide();
			jQuery("#statusImgGreen_"+fin).show();
			if(spjs.ac.instance[fin].multi){
				spjs.ac.multi(fin);
			}else{
				jQuery("#dffs_"+fin).find("input:text,textarea").first().val(spjs.ac.instance[fin].selectedValue);
				// Trigger change event
				try{
					if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
						spjs.dffs.triggerOnChange(fin);
					}
				}catch(ignore){
					// Nothing
				}
				if(index!==""){
					jQuery.each(spjs.ac.instance[fin].sFields[index],function(i,o){
						if(o.pf !== ""){
							try{
								o.val = window[o.pf](o.val);
							}catch(ignore){
								// Nothing
							}
						}else{
							if(o.val.split(";#").length > 1){
								o.val = o.val.split(";#")[1];
							}
						}
						setFieldValue(o.fin,o.val);
						// Trigger change event
						try{
							if(spjs.dffs.ruleObj.triggerMapContext[o.fin] !== undefined){
								spjs.dffs.triggerOnChange(o.fin);
							}
						}catch(ignore){
							// Nothing
						}
						switch(jQuery(fields[o.fin]).attr("FieldType")){
							case "SPFieldChoice":
								jQuery(fields[o.fin]).find("select").trigger("change");
							break;
							case "SPFieldNote":
								jQuery(fields[o.fin]).find("textarea").trigger("change");
							break;
							case "SPFieldMultiChoice":
								jQuery(fields[o.fin]).find("input:checkbox").trigger("change");
							break;
							default:
								jQuery(fields[o.fin]).find("input:text").trigger("blur");
						}
						if(jQuery(fields[o.fin]).find("td.ms-formbody").length > 1){
							if(jQuery(fields[o.fin]).attr("FieldType").match("SPFieldUser") !== null && o.val !== ""){
								jQuery(fields[o.fin]).find("td.ms-formbody").last().html("...");
								spjs.ac.updateReadonlyPeoplePicker(o.fin,0);
							}else{
								jQuery(fields[o.fin]).find("td.ms-formbody").last().html(o.val);
							}
						}
					});
				}
			}	
		}
	},
	"preloadMulti":function(fin){
		var a = spjs.ac.instance[fin], cVal = jQuery("#spjs_ac_"+fin).val();
		jQuery.each(cVal.split(a.multiselectSeparator),function(i,v){
			a.selectedValueMulti.push(v);
			a.selectedIndexMulti.push("");
		});
		if(a.selectedValueMulti.length > 0){
			spjs.ac.multi(fin);
		}
	},
	"idFromString":function(a){
		var s = [];
		jQuery.each(a.split(""),function(i,c){
			s.push(c.charCodeAt(0));
		});
		return s.join("-");
	},
	"multi":function(fin){
		var a = spjs.ac.instance[fin], b = [];		
		if(a.selectedValue !== "" && jQuery.inArray(a.selectedValue,a.selectedValueMulti)<0){
			a.selectedValueMulti.push(a.selectedValue);
		}
		a.selectedValue = "";
		a.selectedIndex = null;
		if(a.selectedValueMulti.length > 0){
			jQuery.each(a.selectedValueMulti,function(i,v){
				b.push("<div class='spjs_ac_multi_selectedWrap'>");
				b.push("<div class='spjs_ac_multi_selected spjs_unselectable'>");
				b.push(v);
				b.push("</div>");
				b.push("<div id='"+fin+"_"+spjs.ac.idFromString(v)+"' class='spjs_ac_multi_removeSelected' onclick='spjs.ac.removeSelection(this,\""+fin+"\");'>");
				b.push("&#10005;");
				b.push("</div>");
				b.push("</div>");
			});
			jQuery("#spjs_acMultiselect_"+fin).html(b.join(""));
			jQuery("#dffs_"+fin).find("input:text,textarea").first().val(a.selectedValueMulti.join(a.multiselectSeparator));
			// Trigger change event
			try{
				if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
					spjs.dffs.triggerOnChange(fin);
				}
			}catch(ignore){
				// Nothing
			}
			jQuery("#spjs_ac_"+fin).val("");
			jQuery("#spjs_acHelp_"+fin).show();
		}
	},
	"removeSelection":function(elm,fin,index){
		if(elm === null){
			return;
		}
		var a = spjs.ac.instance[fin], val = jQuery(elm).parent().find(".spjs_ac_multi_selected").text(), ap = jQuery.inArray(val,a.selectedValueMulti);
		jQuery(elm).parents(".spjs_ac_multi_selectedWrap").remove();
		spjs.ac.instance[fin].selectedValueMulti.splice(ap,1);
		spjs.ac.instance[fin].selectedIndexMulti.splice(ap,1);
		jQuery("#dffs_"+fin).find("input:text,textarea").first().val(a.selectedValueMulti.join(a.multiselectSeparator));
		// Trigger change event
		try{
			if(spjs.dffs.ruleObj.triggerMapContext[fin] !== undefined){
				spjs.dffs.triggerOnChange(fin);
			}
		}catch(ignore){
			// Nothing
		}
		jQuery("#spjs_ac_"+fin).val("");
	},
	"updateReadonlyPeoplePicker":function(fin,c){
		if(c > 10){
			return;
		}
		var ppVal = getFieldValue(fin);
		if(ppVal !== ""){
			jQuery(fields[fin]).find("td.ms-formbody").last().html(ppVal);
		}else{
			setTimeout(function(){
				spjs.ac.updateReadonlyPeoplePicker(fin,(c+1));
			},1000);
		}
	}
};